tellraw @a ["",{"text":"«","bold":true},{"text":"                                      ","bold":true,"strikethrough":true},{"text":"»","bold":true},{"text":"\n"},{"text":"The datapack for rebirth was taken from here","color":"gold"},{"text":":\n"},{"text":"http://www.planetminecraft.com/data-pack/hardcore-respawn/","color":"green","clickEvent":{"action":"open_url","value":"http://www.planetminecraft.com/data-pack/hardcore-respawn/"}},{"text":"\n"},{"text":"«","bold":true},{"text":"                                      ","bold":true,"strikethrough":true},{"text":"»","bold":true},{"text":"\n"},{"text":"The datapack for the collapse of the mines was taken from here","color":"gold"},{"text":":\n"},{"text":"https://www.planetminecraft.com/data-pack/cave-collapse/","color":"green","clickEvent":{"action":"open_url","value":"https://www.planetminecraft.com/data-pack/cave-collapse/"}},{"text":"\n"},{"text":"«","bold":true},{"text":"                                      ","bold":true,"strikethrough":true},{"text":"»","bold":true},{"text":"\n"},{"text":"Datapack loaded successfully!","color":"green"}]

scoreboard objectives add weather dummy
scoreboard objectives add GM dummy
scoreboard objectives add rb dummy
scoreboard objectives add nwd dummy
scoreboard objectives add in_water dummy
scoreboard players set rain weather 0
scoreboard objectives add co.x dummy
scoreboard objectives add co.y dummy
scoreboard objectives add co.z dummy
scoreboard objectives add Deaths deathCount "Deaths"
scoreboard objectives add AddHealth minecraft.used:minecraft.enchanted_golden_apple
scoreboard objectives add GoldApplesEated dummy
gamerule playersSleepingPercentage 101
gamerule commandBlockOutput false
gamerule doLimitedCrafting true
gamerule reducedDebugInfo true

# Initiate Scoreboards
scoreboard objectives add hcrsDeadCheck deathCount
scoreboard objectives add hcrsTimer dummy
scoreboard objectives add hcrsRGP dummy
scoreboard objectives add hcrsSurvShrine dummy
scoreboard objectives add hcrsShrinePrtcl dummy
scoreboard objectives add hcrsCharge dummy
scoreboard objectives add hcrsCharges dummy
scoreboard objectives add hcrsMaxCharge dummy
scoreboard objectives add hcrsRevive dummy
scoreboard objectives add hcrsRevives dummy
scoreboard objectives add hcrsMaxRevive dummy
scoreboard objectives add hcrsRevivesLeft dummy
scoreboard objectives add hcrsShrineCost dummy

# Set Default Settings (First time only)
execute unless score hcrsDummy hcrsRGP matches 0.. run scoreboard players set hcrsDummy hcrsRGP 1
execute unless score hcrsDummy hcrsSurvShrine matches 0.. run scoreboard players set hcrsDummy hcrsSurvShrine 1
execute unless score hcrsDummy hcrsShrinePrtcl matches 0.. run scoreboard players set hcrsDummy hcrsShrinePrtcl 1
execute unless score hcrsDummy hcrsCharge matches 0.. run scoreboard players set hcrsDummy hcrsCharge 1
execute unless score hcrsDummy hcrsMaxCharge matches 0.. run scoreboard players set hcrsDummy hcrsMaxCharge 1
execute unless score hcrsDummy hcrsMaxRevive matches 1.. run scoreboard players set hcrsDummy hcrsMaxRevive 256
execute unless score hcrsDummy hcrsShrineCost matches 0.. run scoreboard players set hcrsDummy hcrsShrineCost 0

scoreboard objectives add cave_c.dummy dummy
scoreboard objectives add cave_c.height dummy

scoreboard players set #player_reach cave_c.dummy 80
scoreboard players set #ray_length cave_c.dummy 0
scoreboard players set #found_block cave_c.dummy 0
scoreboard players set #collapse_count cave_c.dummy 0

scoreboard players set #dataConfigVersion cave_c.dummy 1
execute unless score #worldConfigVersion cave_c.dummy = #dataConfigVersion cave_c.dummy run function cave_collapse:config

execute if score overworld_height cave_c.dummy matches ..-65 run scoreboard players set overworld_height cave_c.dummy -64
execute if score overworld_height cave_c.dummy matches 321.. run scoreboard players set overworld_height cave_c.dummy 320
execute if score collapse_max cave_c.dummy matches ..0 run scoreboard players set collapse_max cave_c.dummy 1