#=-------------------------------------------------=

#              health / respawn

execute as @a[scores={Deaths=..0}] at @s run attribute @s minecraft:generic.max_health base set 20
execute as @a[scores={Deaths=1}] at @s run attribute @s minecraft:generic.max_health base set 18
execute as @a[scores={Deaths=2}] at @s run attribute @s minecraft:generic.max_health base set 16
execute as @a[scores={Deaths=3}] at @s run attribute @s minecraft:generic.max_health base set 14
execute as @a[scores={Deaths=4}] at @s run attribute @s minecraft:generic.max_health base set 12
execute as @a[scores={Deaths=5}] at @s run attribute @s minecraft:generic.max_health base set 10
execute as @a[scores={Deaths=6}] at @s run attribute @s minecraft:generic.max_health base set 8
execute as @a[scores={Deaths=7}] at @s run attribute @s minecraft:generic.max_health base set 6
execute as @a[scores={Deaths=8}] at @s run attribute @s minecraft:generic.max_health base set 4
execute as @a[scores={Deaths=9}] at @s run attribute @s minecraft:generic.max_health base set 2
execute as @a[scores={Deaths=10..}] at @s run gamemode spectator @s[tag=!hcrsAdmin]
execute as @a[scores={Deaths=11..}] at @s run scoreboard players set @s Deaths 10

#=-------------------------------------------------=

#              additional damage for burn

execute as @a[scores={GM=1},nbt=!{ActiveEffects:[{Id:12b}]}] if entity @a[nbt={Fire:150s}] run effect give @s minecraft:instant_damage 1 0 true

#=-------------------------------------------------=

#              kill firework_rocket flying on elytra

execute as @a[nbt={FallFlying:1b}] as @a[nbt={Inventory:[{Slot:102b,id:"minecraft:elytra"}]}] as @s run kill @e[type=minecraft:firework_rocket]

#=-------------------------------------------------=

#              display coords (compass)

execute as @a at @s store result score @s co.x run data get entity @s Pos[0]
execute as @a at @s store result score @s co.y run data get entity @s Pos[1]
execute as @a at @s store result score @s co.z run data get entity @s Pos[2]
execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:compass"}]}] at @s run title @s actionbar [{"text":"| ","color":"dark_gray"},{"text":"X ","color":"green"},{"score":{"name":"@s","objective":"co.x"},"color":"white"},{"text":" | ","color":"dark_gray"},{"text":"Y ","color":"green"},{"score":{"name":"@s","objective":"co.y"},"color":"white"},{"text":" | ","color":"dark_gray"},{"text":"Z ","color":"green"},{"score":{"name":"@s","objective":"co.z"},"color":"white"},{"text":" |","color":"dark_gray"}]
execute as @a[nbt={SelectedItem:{id:"minecraft:compass"}}] at @s run title @s actionbar [{"text":"| ","color":"dark_gray"},{"text":"X ","color":"green"},{"score":{"name":"@s","objective":"co.x"},"color":"white"},{"text":" | ","color":"dark_gray"},{"text":"Y ","color":"green"},{"score":{"name":"@s","objective":"co.y"},"color":"white"},{"text":" | ","color":"dark_gray"},{"text":"Z ","color":"green"},{"score":{"name":"@s","objective":"co.z"},"color":"white"},{"text":" |","color":"dark_gray"}]

#=-------------------------------------------------=

#               damage in the rain

execute unless predicate cmd:clear run scoreboard players set rain weather 1
execute if predicate cmd:clear run scoreboard players set rain weather 0
execute as @a if predicate cmd:biome_c at @s run scoreboard players set @s rb 0
execute as @a unless predicate cmd:biome_c at @s run scoreboard players set @s rb 1
execute as @a at @s if block ~ ~ ~ minecraft:air if blocks ~ ~ ~ ~ 318 ~ ~ ~1 ~ all run scoreboard players set @s nwd 1
execute as @a at @s if block ~ ~ ~ minecraft:air unless blocks ~ ~ ~ ~ 318 ~ ~ ~1 ~ all run scoreboard players set @s nwd 0
execute as @a if entity @s[scores={GM=1}] if score @s rb matches 1 if score @s nwd matches 1 if score rain weather matches 1 unless entity @s[nbt={ActiveEffects:[{Id:29b}]}] unless entity @s[nbt={ActiveEffects:[{Id:13b}]}] at @s run effect give @s minecraft:wither 1 255 true

#=-------------------------------------------------=

#               damage in water

execute as @a at @s if entity @s[scores={GM=1}] unless entity @s[nbt={ActiveEffects:[{Id:20b}]}] unless entity @s[nbt={ActiveEffects:[{Id:29b}]}] unless entity @s[nbt={ActiveEffects:[{Id:13b}]}] if score @s in_water matches 1 run effect give @s minecraft:wither 1 255 true
execute as @a at @s if predicate cmd:in_water run scoreboard players set @s in_water 1
execute as @a at @s unless predicate cmd:in_water run scoreboard players set @s in_water 0

#=-------------------------------------------------=

#               slowness on getting damage

execute as @a[scores={GM=1},nbt={HurtTime:1s}] run effect give @s minecraft:slowness 5 0 true

#=-------------------------------------------------=

#      add health on eat enchanted golden apple

execute as @a[scores={AddHealth=1..}] at @s run scoreboard players remove @s Deaths 1
execute as @a[scores={AddHealth=1..}] at @s run scoreboard players add @s GoldApplesEated 1
execute as @a[scores={AddHealth=1..}] at @s run title @s actionbar [{"text":"Съедено яблок","color":"gold"},{"text":" » ","color":"gray","bold":"true"},{"score":{"name":"@s","objective":"GoldApplesEated"},"color":"red","bold":"true"}]
execute as @a[scores={AddHealth=1..}] at @s run scoreboard players remove @s AddHealth 1

#=-------------------------------------------------=

#              GM (Scoreboard)

execute as @a at @s if entity @s[gamemode=survival] run scoreboard players set @s GM 1
execute as @a at @s if entity @s[gamemode=adventure] run scoreboard players set @s GM 1
execute as @a at @s if entity @s[gamemode=spectator] run scoreboard players set @s GM 0
execute as @a at @s if entity @s[gamemode=creative] run scoreboard players set @s GM 0

#=-------------------------------------------------=